const clientID = 2;
const clientIDString = "msmsgs@msnmsgr.com";
const clientIDCode = "Q1P7W2E4J9R8U3S5";
const MSNPort = "1863";

function MSNObject() {
  // object-specific
  this.bundle = getStringBundle("chrome://msnmsgr/locale/msnmsgr.properties");

  // user-related
  this.passport = '';
  this.password = '';
  this.nickname = '';
  this.status = "HDN";
  this._STATUSMSG = new Array();
  this._STATUSMSG["NLN"] = "Online";
  this._STATUSMSG["BSY"] = "Busy";
  this._STATUSMSG["AWY"] = "Away";
  this._STATUSMSG["IDL"] = "Idling";
  this._STATUSMSG["BRB"] = "Be Right Back";
  this._STATUSMSG["PHN"] = "On the Phone";
  this._STATUSMSG["LUN"] = "Out to Lunch";
  this._STATUSMSG["HDN"] = "Hiding";
  this._STATUSMSG["FLN"] = "Offline";
  this.synVersion = 0;
  this.synching = false;
  this.GTC = "A";
  this.BLP = "AL";
  this.groups = new Array();
  this.contacts = 0;
  this.contactlist = new Array();
  this.contactlist["AL"] = new Array();
  this.contactlist["BL"] = new Array();
  this.contactlist["FL"] = new Array();
  this.contactlist["RL"] = new Array();
  this.unreadEmails = 0;

  // connection-related
  this._SOCKET = new Socket();
  this._TRID = 0;
  this.data = '';
  this.challenge = '';
  this.sessions = new Array();

  // fonts
  this.MMS_FN = "Arial";
  this.MMS_EF_B = false;
  this.MMS_EF_I = false;
  this.MMS_EF_U = false;
  this.MMS_EF_S = false;
  this.MMS_CO = "#000000";

  this.__defineGetter__("TrID", function() {
    this._TRID++;
    return this._TRID;
  });

  this.__defineSetter__("TrID", function(id) {
    this._TRID = id;
  });

  this.__defineGetter__("MMS", function() {
    var mms = "FN=" + escape(this.MMS_FN) + "; EF=";
    if (this.MMS_EF_B)
      mms += "B";
    if (this.MMS_EF_U)
      mms += "U";
    if (this.MMS_EF_I)
      mms += "I";
    if (this.MMS_EF_S)
      mms += "S";
    mms += "; CO=" + swapRedBlue(this.MMS_CO).substr(1, this.MMS_CO.length) + "; CS=0; PF=00";
    return mms;
  });

  this.__defineGetter__("CSS", function() {
    return convertXMMStoStyle(this.MMS);
  });

  this.__defineGetter__("isConnected", function() {
    return this._SOCKET.isConnected;
  });

  this.__defineGetter__("platform", function() {
    return "win 4.00 i386";
  });

  this.__defineGetter__("locale", function() {
    return "0x0409";
  });
}

MSNObject.prototype.loadPrefs = function() {
  try {
    this.MMS_FN = prefBranch.getCharPref("font.name");
    this.MMS_EF_B = prefBranch.getBoolPref("font.bold");
    this.MMS_EF_I = prefBranch.getBoolPref("font.italic");
    this.MMS_EF_U = prefBranch.getBoolPref("font.underline");
    this.MMS_EF_S = prefBranch.getBoolPref("font.strike");
    this.MMS_CO = prefBranch.getCharPref("font.color");
    this.synVersion = prefBranch.getIntPref("cache.synver");
    this.GTC = prefBranch.getCharPref("cache.gtc");
    this.BLP = prefBranch.getCharPref("cache.blp");
    var al = prefBranch.getCharPref("cache.al");
    var bl = prefBranch.getCharPref("cache.bl");
    var fl = prefBranch.getCharPref("cache.fl");
    var rl = prefBranch.getCharPref("cache.rl");
    this.contactlist["AL"] = this.parseContactlist(al);
    this.contactlist["BL"] = this.parseContactlist(bl);
    this.contactlist["FL"] = this.parseContactlist(fl);
    this.contactlist["RL"] = this.parseContactlist(rl);
  }
  catch (ex) {
    this.saveDefaultPrefs();
  }
}

MSNObject.prototype.saveDefaultPrefs = function() {
  prefBranch.setCharPref("font.name", this.MMS_FN);
  prefBranch.setBoolPref("font.bold", this.MMS_EF_B);
  prefBranch.setBoolPref("font.italic", this.MMS_EF_I);
  prefBranch.setBoolPref("font.underline", this.MMS_EF_U);
  prefBranch.setBoolPref("font.strike", this.MMS_EF_S);
  prefBranch.setCharPref("font.color", this.MMS_CO);
  prefBranch.setIntPref("cache.synver", 0);
  prefBranch.setCharPref("cache.gtc", this.GTC);
  prefBranch.setCharPref("cache.blp", this.BLP);
  prefBranch.setCharPref("cache.al", '');
  prefBranch.setCharPref("cache.bl", '');
  prefBranch.setCharPref("cache.fl", '');
  prefBranch.setCharPref("cache.rl", '');
}

MSNObject.prototype.saveCache = function() {
  var al = this.encodeContactlist(this.contactlist["AL"]);
  var bl = this.encodeContactlist(this.contactlist["BL"]);
  var fl = this.encodeContactlist(this.contactlist["FL"]);
  var rl = this.encodeContactlist(this.contactlist["RL"]);
  prefBranch.setIntPref("cache.synver", this.synVersion);
  prefBranch.setCharPref("cache.gtc", this.GTC);
  prefBranch.setCharPref("cache.blp", this.BLP);
  prefBranch.setCharPref("cache.al", al);
  prefBranch.setCharPref("cache.bl", bl);
  prefBranch.setCharPref("cache.fl", fl);
  prefBranch.setCharPref("cache.rl", rl);
}

MSNObject.prototype.parseContactlist = function(contactlistString) {
  var contactlist = new Array();
  contactlistArray = contactlistString.split(" ");
  for(var i = 0; i == contactlistArray.length; i += 2) {
    contactlist[contactlistArray[i]] = new MSNContact(contactlistArray[i], contactlistArray[i+1], "FLN", 0, 0);
  }
  return contactlist;
}

MSNObject.prototype.encodeContactlist = function encodeContactlist(contactlist) {
  var encodedList = "";
  for (var contactID in contactlist) {
    var contact = contactlist[contactID];
    encodedList += contact.email + " " + escape(contact.nickname) + " ";
  }
  return encodedList.substr(0, encodedList.length - 1);
}

MSNObject.prototype.logon = function(name, pass, initstat) {
  this.passport = name;
  this.password = pass;
  this.status = initstat;
  this._SOCKET.connect("messenger.hotmail.com", MSNPort, this);
  this.pinger = setInterval(__ping, 59999);
}

MSNObject.prototype.logout = function() {
  if (this.isConnected) {
    this._SOCKET.sendData('OUT\r\n');
    this._SOCKET.disconnect();
  }
  clearInterval(this.pinger);
  delete this._SOCKET;
  this.saveCache();
  this._SOCKET = new Socket();
  this.contactlist = new Array();
  this.contactlist["FL"] = new Array();
  this.contactlist["RL"] = new Array();
  this.contactlist["BL"] = new Array();
  this.contactlist["AL"] = new Array();
}

MSNObject.prototype.onConnect = function() {
  this._SOCKET.startAsyncRead();
  this._SOCKET.sendData('VER ' + this.TrID + ' MSNP8 CVR0\r\n', 60000);
}

MSNObject.prototype.onClose = function() {
  this._SOCKET = new Socket();
  document.getElementById("signin-button").disabled = false;
  document.getElementById("main-pages").selectedIndex = 0;
}

MSNObject.prototype.onDataAvailable = function(count) {
  this.data += this._SOCKET.readData(count);
  while (this.data != '') {
    var i = this.data.indexOf('\r\n');
    if (i == -1) { return }
    var data = this.data.substr(0, i);
    this.data = this.data.substr(i+2);
    dump("<<< " + data + '\n');
    var param = data.split(" ");
    switch (param[0]) {
      case "VER":
        this._SOCKET.sendData('CVR ' + this.TrID + ' ' + this.locale + ' ' + this.platform + ' MSNMSGR 5.0.0575 MSMSGS ' + this.passport + '\r\n', 60000);
        break;
      case "CVR":
        this._SOCKET.sendData('USR ' + this.TrID + ' TWN I ' + this.passport + '\r\n', 60000);
      case "XFR":
        if (param[2] == "NS") {
          this._SOCKET.disconnect(1);
          var host = param[3].split(":");
          this.TrID = 0;
          this._SOCKET = new Socket();
          this._SOCKET.connect(host[0], host[1], this);
        }
        else if (param[2] == "SB") {
          var host = param[3].split(":");
          this.newSession.open(host[0], host[1], param[5]);
          delete this.newSession;
        }
        break;
      case "USR":
        if (param[3] == "S") {
          this.challenge = param[4];
          var httpsocket = new HttpSocket();
          dump("Opening connection to Passport Nexus...\r\n");
          httpsocket.openNexus("https://nexus.passport.com/rdr/pprdr.asp", this);
        }
        else if (param[2] == "OK") {
          this.nickname = unescape(param[4]);
          document.getElementById("SignInProgress").mode = "determined";
          this._SOCKET.sendData('SYN ' + this.TrID + ' ' + this.synVersion + '\r\n', 60000);
        }
        break;
      case "SYN":
        if (parseInt(param[2]) == this.synVersion) {
          setupContactlist();
          this.changeStatus(this.status);
          loginSuccessful();
        }
        else {
          this.synching = true;
          this.synVersion = parseInt(param[2]);
          this.contacts = parseInt(param[3]);
          this.groups.length = parseInt(param[4]);
          this.contactlist["AL"] = new Array();
          this.contactlist["BL"] = new Array();
          this.contactlist["FL"] = new Array();
          this.contactlist["RL"] = new Array();
        }
        break;
      case "GTC":
        this.GTC = param[1];
        break;
      case "BLP":
        this.BLP = param[1];
        break;
      case "PRP":
        // no phone support
        break;
      case "LSG":
        var groupID = param[1];
        this.groups[groupID] = param[unescape(param[2])];
        break;
      case "LST":
        if ((param[3] & 1) == 1) {
          this.contactlist["FL"][param[1]] = new MSNContact(param[1], param[2], "FLN", param[4], 0);
        }
        if ((param[3] & 2) == 2) {
          this.contactlist["AL"][param[1]] = new MSNContact(param[1], param[2], "FLN", 0, 0);
        }
        if ((param[3] & 4) == 4) {
          this.contactlist["BL"][param[1]] = new MSNContact(param[1], param[2], "FLN", 0, 0);
        }
        if ((param[3] & 8) == 8) {
          this.contactlist["RL"][param[1]] = new MSNContact(param[1], param[2], "FLN", 0, 0);
        }
        if ((param[3] & 14) == 8) {
          if (this.GTC == "A") {
            window.openDialog("chrome://msnmsgr/content/contactaddprompt.xul", "_blank", "chrome,resizable", param[1], param[2]);
          }
          else {
            this.Contacts["AL"][param[1]] = new MSNContact(param[1], param[2], "FLN", 0, 0);
          }
        }
        if (this.contacts != 0) { this.contacts--; }
        if (this.contacts == 0 && this.synching == true) {
          this.synching = false;
          setupContactlist();
          this.changeStatus(this.status);
          loginSuccessful();
        }
        break;
      case "BPR":
        // no phone support
        break;
      case "MSG":
        if (this.data >= param[3]) {
          var msgData = this.data.substr(0, param[3]);
          this.data = this.data.substr(param[3]);
          var parts = msgData.split('\r\n\r\n');
          var headers = parseHeaders(parts[0]);
          switch (headers["content-type"]) {
            case "text/x-msmsgsinitialemailnotification; charset=UTF-8":
              var msgData = parseHeaders(parts[1]);
              this.unreadEmails = parseInt(msgData["inbox-unread"]);
              updateEmailItem(this.unreadEmails);
              break;
            case "text/x-msmsgsemailnotification; charset=UTF-8":
              this.unreadEmails++;
              updateEmailItem(this.unreadEmails);
              break;
            case "text/x-msmsgsactivemailnotification; charset=UTF-8":
              var msgData = parseHeaders(parts[1]);
              if (msgData["src-folder"] == "ACTIVE") {
                this.unreadEmails -= parseInt(msgData["message-delta"]);
                updateEmailItem(this.unreadEmails);
              }
              break;
          }
        }
      case "NOT":
        // strip it out for now
        this.data = this.data.substr(param[1]);
        break;
      case "ILN":
        var contact = this.contactlist["FL"][param[3]];
        contact.nickname = unescape(param[4]);
        contact.status = param[2];
        contact.clientID = param[5];
        if (!(this.isContactInList(contact.email, "BL"))) {
          addOnlineContact(contact.email, contact.nickname, contact.status);
        }
        else {
          addOnlineContact(contact.email, contact.nickname, "BLK");
        }
        break;
      case "FLN":
        var contact = this.contactlist["FL"][param[1]];
        contact.status = "FLN";
        if (!(this.isContactInList(contact.email, "BL"))) {
          addOfflineContact(contact.email, contact.nickname, contact.status);
        }
        else {
          addOfflineContact(contact.email, contact.nickname, "BLK");
        }
        break;
      case "NLN":
        var contact = this.contactlist["FL"][param[2]];
        param[3] = unescape(param[3]);
        if (contact.status == "FLN") {
          contact.nickname = param[3];
          contact.status = param[1];
          contact.clientID = param[4];
          if (!(this.isContactInList(contact.email, "BL"))) {
            addOnlineContact(contact.email, contact.nickname, contact.status);
          }
          else {
            addOnlineContact(contact.email, contact.nickname, "BLK");
          }
        }
        else {
          if (contact.status != param[1]) {
            contact.status = param[1];
            if (!(this.isContactInList(contact.email, "BL"))) {
              contactStatusChanged(contact.email, contact.status);
            }
            else {
              contactStatusChanged(contact.email, "BLK");
            }
          }
          if (contact.nickname != param[3]) {
            contact.nickname = param[3];
            contactNicknameChanged(contact.email, contact.nickname);
          }
          if (contact.clientID != param[4]) {
            contact.clientID = param[4];
          }
        }
        break;
      case "CHL":
        var md5 = hex_md5(param[2] + clientIDCode);
        this._SOCKET.sendData('QRY ' + this.TrID + ' ' + clientIDString + ' ' + md5.length + '\r\n' + md5, 60000);
        dump('\r\n');
        break;
      case "CHG":
        this.status = param[2];
        statusChanged(this.status);
        break;
      case "REA":
        this.synVersion = parseInt(param[2]);
        this.nickname = unescape(param[4]);
        nicknameChanged(this.nickname);
        break;
      case "ADD":
        this.synVersion = param[3];
        this.contactlist[param[2]][param[4]] = new MSNContact(param[4], param[5], "FLN", 0, 0);
        if (param[2] == "FL") {
          addContact(this.contactlist["FL"][param[4]]);
        }
        break;
      case "REM":
        delete this.contactlist[param[2]][param[4]];
        this.synVersion = param[3];
        if (param[2] == "FL") {
          removeContact(param[4]);
        }
        break;
      case "RNG":
        var win = this.getSessionWindow(param[5]);
        var newSession = new MSNSession(this, win);
        var host = param[2].split(":");
        newSession.answer(host[0], host[1], param[4], param[1])
        if (win != null) {
          win._SESSION.exit();
          win._SESSION = newSession;
        }
        break;
      case "201":
        alert("Error 201: Invalid parameter\r\n\r\nThe e-mail address you tried to add is invalid.");
        break;
      case "209":
        alert("Error 209: Nickname change illegal\r\n\r\nMSN doesn't like your new display name.");
        break;
      case "210":
        alert("Error 210: Principal list full\r\n\r\nYour contact list is full.");
        break;
      case "500":
        alert("Error 500: Internal server error\r\n\r\nMSN is down.");
        break;
      case "540":
        alert("Error 540: Challenge response failed\r\n\r\nPlease report this!");
        break;
      case "601":
        alert("Error 601: Server is unavailable");
        break;
      case "800":
        alert("Error 800: Changing too rapidly\r\n\r\nYou're changing your status or display name too fast");
        break;
      case "910":
        alert("Error 910: Server too busy");
        break;
      case "913":
        alert("Error 913: Not allowed when hiding\r\n\r\nYou're not allowed to start conversations when you're hiding.");
        break;
      case "921":
        alert("Error 921: Server too busy");
        break;
    }
  }
}

MSNObject.prototype.onNexusDataAvailable = function(status, httpsocket) {
  loginserverurl = "https://" + extractFromHeader(httpsocket.socket.getResponseHeader("PassportURLs"), "DALogin");
  dump("Login Server URL received. Opening connection to Login Server...\r\n");
  httpsocket.openLogin(loginserverurl, this.passport, this.password, this.challenge, this);
}

MSNObject.prototype.onLoginDataAvailable = function(status, httpsocket) {
  switch (status) {
    case 200:
      var ticket = extractFromHeader(httpsocket.socket.getResponseHeader("Authentication-Info"), "from-PP");
      ticket = ticket.substr(1, ticket.length - 2);
      dump("Ticket received. Sending ticket to Notification Server...\n");
      this._SOCKET.sendData('USR ' + this.TrID + ' TWN S ' + ticket + '\n', 60000);
      break;
    case 302:
      dump("We\'re being redirected!\n");
      break;
    case 401:
      dump("We failed!\n");
      break;
    default:
      dump("Unexpected error number: " + status + '\n');
      break;
  }
}

MSNObject.prototype.changeStatus = function(status) {
  this._SOCKET.sendData('CHG ' + this.TrID + ' ' + this.status + ' ' + clientID + '\r\n', 15000);
}

MSNObject.prototype.changeNickname = function(nickname) {
  this._SOCKET.sendData('REA ' + this.TrID + ' ' + this.passport + ' ' + escape(nickname) + '\r\n', 15000);
}

MSNObject.prototype.addContact = function(email, nick, group, list) {
  if (list == "FL") {
    this._SOCKET.sendData('ADD ' + this.TrID + ' ' + list + ' ' + email + ' ' + nick + ' ' + group + '\r\n', 60000);
  }
  else {
    if (!(this.isContactInList(email, list))) {
      this._SOCKET.sendData('ADD ' + this.TrID + ' ' + list + ' ' + email + ' ' + nick + '\r\n', 60000);
    }
  }
}

MSNObject.prototype.removeContact = function(list, email) {
  var group = this.contactlist[list][email].group;
  if (list == "FL") {
    this._SOCKET.sendData('REM ' + this.TrID + ' ' + list + ' ' + email + ' ' + group + '\r\n', 60000);
  }
  else {
    this._SOCKET.sendData('REM ' + this.TrID + ' ' + list + ' ' + email + '\r\n', 60000);
  }
}

MSNObject.prototype.moveContactBetweenLists = function(removeList, addList, email, nick) {
  this.removeContact(removeList, email);
  this.addContact(email, nick, 0, addList);
  this.contactlist[addList][email] = this.contactlist[removeList][email];
}

MSNObject.prototype.isContactInList = function(email, list) {
  return email in this.contactlist[list];
}

MSNObject.prototype.getContactStatus = function(email) {
  return this.contactlist["FL"][email].status;
}

MSNObject.prototype.grabSession = function(session) {
  this.newSession = session;
  this._SOCKET.sendData('XFR ' + this.TrID + ' SB\r\n', 60000);
}

MSNObject.prototype.registerSession = function(session) {
  this.sessions[session.sessionID] = session;
}

MSNObject.prototype.unregisterSession = function(sessionID) {
  delete this.sessions[sessionID];
}

MSNObject.prototype.getSessionWindow = function(email) {
  var win = null;
  for (var sessionID in this.sessions) {
    var session = this.sessions[sessionID];
    var contact = session.getFirstContactID();
    if (contact == email && session.getContactCount() == 1) {
      win = session._WINDOW;
    }
  }
  return win;
}

MSNObject.prototype.FontChanged = function() {
  for (var i in this.sessions) {
    var session = this.sessions[i];
    if (typeof(session._WINDOW) == "object") { session._WINDOW.FontChanged(); }
  }
}

function __ping() {
    client._SOCKET.sendData('PNG\r\n', 60000);
}

function extractFromHeader(headervalue, fieldkey) {
  var field = headervalue.substr(headervalue.search(fieldkey));
  return field.substr(fieldkey.length + 1, field.search(",") - (fieldkey.length + 1));
}

function MSNContact(email, nick, status, group, clientID) {
  this.email = email;
  this.nickname = unescape(nick);
  this.status = status;
  this.group = group;
  this.clientID = clientID;
}