function MSNSession(client, win) {
  // object-specific
  this.bundle = getStringBundle('chrome://msnmsgr/locale/session.properties');
  this._WINDOW = win;
  this._CLIENT = client;

  // user-related
  this.Contacts = new Array();
  this.noContacts = false;

  // connection-related
  this._SOCKET = new Socket();
  this._TRID = 0;
  this.data = '';

  // session-related
  this.sessionID = 0;
  this.callingContact = true;
  this.msgBuffer = new Array();

  this.__defineGetter__("TrID", function() {
    this._TRID++;
    return this._TRID;
  });

  this.__defineGetter__("isConnected", function() {
    return this._SOCKET.isConnected;
  });
}

MSNSession.prototype.open = function(host, port, cki) {
  this.__initialSend = 'USR ' + this.TrID + ' ' + this._CLIENT.passport + ' ' + cki + '\r\n';
  this._SOCKET.connect(host, port, this);
}

MSNSession.prototype.exit = function() {
  if (this._SOCKET.isConnected) {
    this._SOCKET.sendData('OUT\r\n');
    this._SOCKET.disconnect();
  }
  this._CLIENT.unregisterSession(this.sessionID);
}

MSNSession.prototype.onConnect = function() {
  this._SOCKET.startAsyncRead();
  this._SOCKET.sendData(this.__initialSend);
  delete this.__initialSend;
}

MSNSession.prototype.onStreamClose = function(status) {
  this._SOCKET = new Socket();
}

MSNSession.prototype.onClose = function() {
  this._SOCKET = new Socket();
}

MSNSession.prototype.onDataAvailable = function(count) {
  this.data += this._SOCKET.readData(count);
  while (this.data != '') {
    var i = this.data.indexOf('\r\n');
    if (i == -1) { return }
    var data = this.data.substr(0, i);
    this.data = this.data.substr(i+2);
    dump("<<< " + data + '\r\n');
    var param = data.split(" ");
    switch (param[0]) {
      case "USR":
        if (param[2] == "OK") {
          var contact = this._WINDOW._CONTACT;
          delete this._WINDOW._CONTACT;
          if (contact) this.invite(contact);
        }
        break;
      case "CAL":
        if (param[2] == "RINGING" && this.getContactCount() != 1) {
          this.sessionID = parseInt(param[3]);
          this._CLIENT.registerSession(this);
        }
        else {
          this.callingContact = true;
        }
        break;
      case "JOI":
        var contact;
        if (this._CLIENT.isContactInList(param[1], "FL")) {
          contact = this._CLIENT.contactlist["FL"][param[1]];
        }
        else {
          contact = new MSNContact(param[1], unescape(param[2]), "NLN", 0, 0);
        }
        if (this.getContactCount() != 1) {
          this.Contacts.push(contact);
          this._WINDOW.onUsersChanged();
        }
        if (this.getContactCount() > 1) {
          var joinMsg = this.bundle.GetStringFromName('joinMessage');
          var msgNode = createNotifyNode(this._WINDOW.document, joinMsg.replace("%S", unescape(param[2])));
          this._WINDOW.appendAndScroll(msgNode);
        }
        this.noContacts = false;
        this.callingContact = false;
        this._WINDOW.dontSend = false;
        if (this.msgBuffer.length != 0) {
          for (var i in this.msgBuffer) {
            this.send(this.msgBuffer[i]);
          }
          this.msgBuffer = new Array();
        }
        break;
      case "BYE":
        var contact = this.getContact(param[1]);
        if (this.getContactCount() == 1) {
          this.noContacts = true;
        }
        else {
          this.Contacts.splice(getContactIndex(param[1], 1));
          var leaveMsg = this.bundle.GetStringFromName('leaveMessage');
          var msgNode = createNotifyNode(this._WINDOW.document, leaveMsg.replace("%S", contact.nickname));
          this._WINDOW.appendAndScroll(msgNode);
          this._WINDOW.onUsersChanged();
        }
        break;
      case "ANS":
        this._CLIENT.registerSession(this);
        break;
      case "IRO":
        var contact;
        if (this._CLIENT.isContactInList(param[4], "FL")) {
          contact = this._CLIENT.contactlist['FL'][param[4]];
        }
        else {
          contact = new MSNContact(param[4], unescape(param[5]), "NLN", 0, 0);
        }
        this.Contacts.push(contact);
        break;
      case "MSG":
        if (this.data.length >= param[3]) {
          var msgdata = this.data.substr(0, param[3]);
          this.data = this.data.substr(param[3]);
          var parts = msgdata.split('\r\n\r\n', 2);
          var headers = parseHeaders(parts[0]);
          msgdata = parts[1];
          dump(msgdata + '\r\n');
          if (this._WINDOW == null) {
            if (headers["content-type"] != "text/x-msmsgscontrol") {
              this._WINDOW = window.open('chrome://msnmsgr/content/session.xul', '_blank', 'chrome,resizable');
              this._WINDOW._SESSION = this;
              this._WINDOW._MSG = new Array(unescape(param[2]), param[1], headers, msgdata)
            }
          }
          else {
            this._WINDOW.onMessageReceived(unescape(param[2]), param[1], headers, msgdata);
          }
        }
        else {
          this.data = data + this.data;
          return;
        }
        break;
      case "217":
        alert("Error 217: Principal not on-line\r\n\r\nThe contact you're trying to talk with is off-line.");
        break;
      default:
        alert('Session  ' + data);
        break;
      }
  }
}

MSNSession.prototype.invite = function(contact) {
  this._SOCKET.sendData('CAL ' + this.TrID + ' ' + contact + '\r\n');
}

MSNSession.prototype.answer = function(host, port, cki, sessionID) {
  this._SESSIONID = sessionID;
  this.__initialSend = 'ANS ' + this.TrID + ' ' + this._CLIENT.passport + ' ' + cki + ' ' + sessionID + '\r\n';
  this._SOCKET.connect(host, port, this);
}

MSNSession.prototype.send = function(msgtext) {
  var msg = 'MIME-Version: 1.0\r\n';
  msg += "Content-Type: text/plain; charset=UTF-8\r\n";
  msg += "X-MMS-IM-Format: " + this._CLIENT.MMS + "\r\n";
  msg += "\r\n";
  msg += msgtext;
  msg = "MSG " + this.TrID + " N " + msg.length + "\r\n" + msg;
  this._SOCKET.sendData(msg);
  dump('\r\n');
}

MSNSession.prototype.sendTyping = function() {
  var msg = 'MIME-Version: 1.0\r\n';
  msg += "Content-Type: text/x-msmsgscontrol\r\n";
  msg += "TypingUser: " + this._CLIENT.passport + "\r\n";
  msg += "\r\n";
  msg = "MSG " + this.TrID + " U " + msg.length + "\r\n" + msg;
  this._SOCKET.sendData(msg);
}

MSNSession.prototype.cancelInvite = function(cookie, cancelCode) {
    var msg = 'MIME-Version: 1.0\r\n';
    msg += "Content-Type: text/x-msmsgsinvite; charset=UTF-8\r\n";
    msg += "\r\n";
    msg += "Invitation-Command: CANCEL\r\n";
    msg += "Invitation-Cookie: " + cookie + "\r\n";
    msg += "Cancel-Code: " + cancelCode + "\r\n";
    msg = "MSG " + this.TrID + " N " + msg.length + "\r\n" + msg;
    this._SOCKET.sendData(msg);
}

MSNSession.prototype.getSessionID = function() {
  return this.sessionID;
}

MSNSession.prototype.isCallingContact = function() {
  return this.callingContact;
}

MSNSession.prototype.bufferMsg = function(msgText) {
  this.msgBuffer.push(msgText);
}

MSNSession.prototype.recallContactIfGone = function(email) {
  if (this.noContacts == true) {
    this.invite(email);
  }
}

MSNSession.prototype.getContactCount = function() {
  return this.Contacts.length;
}

MSNSession.prototype.getFirstContactID = function() {
  return this.Contacts[0].email;
}

MSNSession.prototype.getContactIndex = function(email) {
  var index;
  for (var i in this.Contacts) {
    if (this.Contacts[i].email == email) {
      index = i;
    }
  }
  return index;
}

MSNSession.prototype.getContact = function(email) {
  var contact = null;
  for (var i in this.Contacts) {
    if (this.Contacts[i].email == email) {
      contact = this.Contacts[i];
    }
  }
  return contact;
}